-----------------------------------------------------------------------------------------
-- Start Activity
-----------------------------------------------------------------------------------------

function NuclearSiloMission:StartActivity()
    print("START! -- NuclearSiloMission:StartActivity()!");

	self.FightStage = { PAUSE = 0, FIRSTDROP = 1, WIN = 2, AMBUSH = 3, FIGHTSTAGECOUNT = 4 };
	
	self.CurrentFightStage = self.FightStage.FIRSTDROP ;
	self.SpawnTimer = Timer();
	self.ScreenChange = false;
	self.BrainHasLanded = false;
	self.theRocket = nil;
	self.CPUBrain = nil;
	self.braindead = {};
	self.GunListA = { "Uzi","Assault Rifle","Shotgun","Auto Shotgun","M16","Rocket Launcher" };

	self.MOIDLimit = 220;	
	
	droidlimit = 50 ;
	droidcount = 0 ;
	--------------------------
	-- Set up teams
	self.playerTeam = Activity.TEAM_1;
	-- Team 2 is always CPU
	self.CPUTeam = Activity.TEAM_2;
	--------------------------
	-- Set up players

	for player = 0, self.PlayerCount - 1 do
	-- Check if we already have a brain assigned
		if not self:GetPlayerBrain(player) then
			self.braindead[player] = false;
			local brainCase = CreateActor("Brain Case");
			brainCase.Pos = Vector(2008, 1436);
			brainCase.Team = self:GetTeamOfPlayer(player);
			-- brainCase:SetControllerMode(Controller.CIM_AI, -1);
			-- Let the spawn into the world, passing ownership
			self:SetPlayerBrain(self.brainCase,player);
			MovableMan:AddActor(brainCase);
			foundBrain = brainCase;

			-- If we can't find an unassigned brain in the scene to give each player, then force to go into editing mode to place one
			if not foundBrain then
				self.ActivityState = Activity.EDITING;
				AudioMan:ClearMusicQueue();
				AudioMan:PlayMusic("Base.rte/Music/dBSoundworks/ccambient4.ogg", -1, -1);
			else
				-- Set the found brain to be the selected actor at start
				self:SetPlayerBrain(foundBrain, player);
				-- self:SetViewState(Activity.ACTORSELECT, player);
				-- self:SwitchToActor(foundBrain, player, self:GetTeamOfPlayer(player));
				-- SceneMan:SetScroll(self:GetPlayerBrain(player).Pos, player);
				-- self:SetActorSelectCursor(Vector(3024, 324), player);
				-- self:SetLandingZone(self:GetPlayerBrain(player).Pos, player);
				-- Set the observation target to the brain, so that if/when it dies, the view flies to it in observation mode
				self:SetObservationTarget(self:GetPlayerBrain(player).Pos, player)
			end
		end
	end

	-- Spawn Rocket MK2, right on the rocket dock.
	theRocket = CreateACRocket ("Rocket MK2");
	theRocket.Pos = Vector (1926,1512);
	theRocket.Team = self.playerTeam;
	theRocket.AIMode = Actor.AIMODE_STAY;
	MovableMan:AddActor(theRocket);

	-- Spawn player's defense
	local soldierLeft = CreateAHuman("Soldier Light");
	soldierLeft:AddInventoryItem(CreateHDFirearm("Gatling Gun", "Coalition.rte"));
	soldierLeft.Pos = Vector (1456,1341);
	soldierLeft.Team = self.playerTeam;
	soldierLeft.AIMode = Actor.AIMODE_SENTRY;
	MovableMan:AddActor(soldierLeft);

	local soldierTop = CreateAHuman("Soldier Light");
	soldierTop:AddInventoryItem(CreateHDFirearm("SMG", "Coalition.rte"));
	soldierTop.Pos = Vector (1920,636);
	soldierTop.Team = self.playerTeam;
	soldierTop.AIMode = Actor.AIMODE_SENTRY;
	MovableMan:AddActor(soldierTop);	

	-- Spawn "control chip team" soldiers
	local soldier1 = CreateAHuman("Soldier Light");
	soldier1:AddInventoryItem(CreateHDFirearm(self.GunListA[math.random(#self.GunListA)]));
	soldier1.Pos = Vector (228,840);
	soldier1.Team = self.playerTeam;
	soldier1.AIMode = Actor.AIMODE_SENTRY;
	MovableMan:AddActor(soldier1);
	
	local soldier2 = CreateAHuman("Soldier Light");
	soldier2:AddInventoryItem(CreateHDFirearm(self.GunListA[math.random(#self.GunListA)]));
	soldier2:AddInventoryItem(CreateHeldDevice("Control Chip"));
	soldier2.Pos = Vector (132,768);
	soldier2.Team = self.playerTeam;
	soldier2.AIMode = Actor.AIMODE_SENTRY;
	MovableMan:AddActor(soldier2);
	
	local soldier3 = CreateAHuman("Soldier Light");
	soldier3:AddInventoryItem(CreateHDFirearm(self.GunListA[math.random(#self.GunListA)]));
	soldier3.Pos = Vector (312,888);
	soldier3.Team = self.playerTeam;
	soldier3.AIMode = Actor.AIMODE_SENTRY;
	MovableMan:AddActor(soldier3);

	-- Set up AI modes for the Actors that have been added to the scene by the scene definition
    for actor in MovableMan.AddedActors do
       	if actor.Team == self.CPUTeam then
			-- actor:SetControllerMode(Controller.CIM_AI, -1);
            actor.AIMode = Actor.AIMODE_PATROL;
        end
    end
end
--------------------------- Generate dummies for attack ------
function NuclearSiloMission:MakeDummy(whichMode)
    local dummy;
	dummy = CreateAHuman("Dummy");
    local which = math.random();
    local gun;
    which = math.random();
    if which > 0.85 then
        gun = CreateHDFirearm("Blaster","Dummy.rte");
    elseif which > 0.76 then
        gun = CreateHDFirearm("Repeater","Dummy.rte");
    elseif which > 0.50 then
        gun = CreateHDFirearm("Grenade Launcher","Dummy.rte");
    elseif which > 0.35 then
        gun = CreateHDFirearm("Rail Pistol","Dummy.rte");
    elseif which > 0.15 then
        gun = CreateHDFirearm("M16");
    else
        gun = CreateHDFirearm("Shotgun");
    end

    dummy:AddInventoryItem(gun);
	-- if dummy in AIMODE_GOTO , send him through the left bunker tunnels.
	if whichMode == Actor.AIMODE_GOTO then
		dummy:AddAISceneWaypoint(Vector(1536,1116));
		dummy:AddAISceneWaypoint(Vector(1248,1248));
		dummy:AddAISceneWaypoint(Vector(1200,1344));
		dummy:AddAISceneWaypoint(Vector(1380,1440));
		dummy:AddAISceneWaypoint(Vector(1764,1536));
	else
		dummy.AIMode = whichMode;
	end
    return dummy;
end
-----------------------------------------------------------------------------------------
-- Update Activity
-----------------------------------------------------------------------------------------

function NuclearSiloMission:UpdateActivity()

------------------------------
--If the Rocket explodes, the game is over
--------------------------------
if MovableMan:IsActor(theRocket) then
	if theRocket.AIMode > 20  and self.CurrentFightStage ~= self.FightStage.WIN then
		if not (self.ActivityState == Activity.OVER) then
			self.WinnerTeam = Activity.TEAM_2;
			ActivityMan:EndActivity()
		end
	end
end
--------------------------
    -- Iterate through all human players

    for player = 0, self.PlayerCount - 1 do
        -- The current player's team
        local team = self:GetTeamOfPlayer(player);
        
        -- Make sure the game is not already ending
        if self.ActivityState ~= Activity.OVER then
            -- Check if any player's brain is dead
            local brain = self:GetPlayerBrain(player);
            if not brain or not MovableMan:IsActor(brain) or not brain:HasObjectInGroup("Brains") then
                self:SetPlayerBrain(nil, player);
                -- Try to find a new unasigned brain this player can use instead, or if his old brain entered a craft
                local newBrain = MovableMan:GetUnassignedBrain(team);
                -- Found new brain actor, assign it and keep on truckin'
                if newBrain and self.braindead[player] == false then
					self:SetPlayerBrain(newBrain, player);
					if MovableMan:IsActor(newBrain) then
						self:SwitchToActor(newBrain, player, team);
					end
                else                
					FrameMan:SetScreenText("Your brain has been lost!", player, 333, -1, false);
					self.braindead[player] = true;
                    -- Now see if all brains of self player's team are dead, and if so, end the game
                    --if not MovableMan:GetClosestBrainActor(team) then
						if self.ActivityState ~= Activity.OVER then
							self.WinnerTeam = self:OtherTeam(team);
							ActivityMan:EndActivity();
						end
                    --end
                    self:ResetMessageTimer(player);
                end
            else
                -- Update the observation target to the brain, so that if/when it dies, the view flies to it in observation mode
                self:SetObservationTarget(brain.Pos, player)
            end
        -- Game over, show the appropriate messages until a certain time
        elseif not self.GameOverTimer:IsPastSimMS(self.GameOverPeriod) then
		-- TODO: make more appropriate messages here for run out of funds endings
            if team == self.WinnerTeam then
				if self.ActivityState ~= Activity.OVER then
					FrameMan:SetScreenText("Well done, you retrieved the item!", player, 0, -1, false);
					ActivityMan:EndActivity();
				end
            else
				if self.ActivityState ~= Activity.OVER then
					FrameMan:SetScreenText("Your brain has been lost!", player, 0, -1, false);
					ActivityMan:EndActivity();
				end
            end
        end
    end
-- end
    ------------------------------------------------
    -- Iterate through all teams
    for team = 0, self.TeamCount - 1 do
        -------------------------------------------
		-- Check for victory conditions
		-- Make sure the game isn't already ending
		if (not (self.ActivityState == Activity.OVER)) and (not (team == self.CPUTeam)) then
		end
    end

	-- MARK THE OBJECTIVES ------------------------
    -- Clear all objective markers, they get re-added each frame
    self:ClearObjectivePoints();

	-- Chip on the ground
	for item in MovableMan.Items do
		if item:HasObject("Control Chip") then
			self:AddObjectivePoint("Pick up!", item.AboveHUDPos, Activity.TEAM_1, GameActivity.ARROWDOWN);
		end
	end
       -- the Rocket

	if MovableMan:IsActor(theRocket) then
		if theRocket.AIMode < 20 then
			if not theRocket:HasObject("Control Chip") then
				self:AddObjectivePoint("Rocket", theRocket.AboveHUDPos, Activity.TEAM_1, GameActivity.ARROWDOWN);
			end
			-- Actor markers
			for actor in MovableMan.Actors do
				if actor:HasObject("Control Chip") then
					if theRocket:HasObject("Control Chip") then
						if theRocket.AIMode == 7 then
							self:AddObjectivePoint("Release from the dock", actor.AboveHUDPos + Vector(0, -32), Activity.TEAM_1, GameActivity.ARROWUP);				
						else
							self:AddObjectivePoint("Launch into orbit!", actor.AboveHUDPos + Vector(0, -32), Activity.TEAM_1, GameActivity.ARROWUP);
						end
					else
						self:AddObjectivePoint("Get to the Rocket!", actor.AboveHUDPos, Activity.TEAM_1, GameActivity.ARROWDOWN);
					end
				end
			end
		end
	else
		if self.ActivityState ~= Activity.OVER then
			for player = 0, self.PlayerCount - 1 do
				local team = self:GetTeamOfPlayer(player);
				self.WinnerTeam = self:OtherTeam(team);
				FrameMan:SetScreenText("Your rocket has been lost!", player, 0, -1, false);
				ActivityMan:EndActivity();
			end
		end
	end

	-- BATTLE LOGIC
	if self.CurrentFightStage == self.FightStage.FIRSTDROP and self.SpawnTimer:IsPastSimMS(15000) and MovableMan:GetMOIDCount() <= self.MOIDLimit then
		 -- See if there is a designated LZ Area for attackers, and only land over it
		local attackLZ = SceneMan.Scene:GetArea("LZ Team 2");
		if attackLZ then
			local ship1 = CreateACDropShip("Drop Ship");
			local dummyA = self:MakeDummy(Actor.AIMODE_BRAINHUNT);
			local dummyB = self:MakeDummy(Actor.AIMODE_GOTO);
			local dummyC = self:MakeDummy(Actor.AIMODE_GOTO);
			ship1:AddInventoryItem(dummyA);
			ship1:AddInventoryItem(dummyB);
			ship1:AddInventoryItem(dummyC);
			ship1.Pos.X = attackLZ:GetRandomPoint().X;
			ship1.Pos.Y = 0;
			ship1.Team = self.CPUTeam;
			MovableMan:AddActor(ship1);
		end
	
		attackLZ = SceneMan.Scene:GetArea("LZ Right");
		if attackLZ then
			local ship2 = CreateACDropShip("Drop Ship");
			local dummyD = self:MakeDummy(Actor.AIMODE_BRAINHUNT);
			local dummyE = self:MakeDummy(Actor.AIMODE_BRAINHUNT);
			local dummyF = self:MakeDummy(Actor.AIMODE_BRAINHUNT);
			ship2:AddInventoryItem(dummyD);
			ship2:AddInventoryItem(dummyE);
			ship2:AddInventoryItem(dummyF);
			ship2.Pos.X = attackLZ:GetRandomPoint().X;
			ship2.Pos.Y = 0;
			ship2.Team = self.CPUTeam;
			MovableMan:AddActor(ship2);
		end
	
		-- Advance the stage ?
		self.SpawnTimer:Reset()
		droidcount = 0;
		for actor in MovableMan.Actors do
			if actor.Team == self.CPUTeam then
				droidcount = droidcount +1 ;
			end
		end 

		if droidcount<droidlimit then
			--continue producing them
		else
			self.CurrentFightStage = self.FightStage.PAUSE;
		end
	end
end
-----------------------------------------------------------------------------------------
-- End Activity
-----------------------------------------------------------------------------------------

function NuclearSiloMission:EndActivity()
    	print("Mission completed! -- NuclearSiloMission:EndActivity()!");
end
-----------------------------------------------------------------------------------------
-- Craft Entered Orbit
-----------------------------------------------------------------------------------------

function NuclearSiloMission:CraftEnteredOrbit()
    if self.OrbitedCraft:HasObject("Control Chip") then
		if theRocket:HasObject("Control Chip") then
			-- WINRAR!
			self.CurrentFightStage = self.FightStage.WIN;
			self.WinnerTeam = Activity.TEAM_1;
			ActivityMan:EndActivity();
		else
			-- the chip is in orbit but on another ship , FAIL !
			self.WinnerTeam = Activity.TEAM_2;
			ActivityMan:EndActivity();
		end
    end
end